import org.junit.Test;

import java.io.FileNotFoundException;

/*
 * Lauren Wang & James White
 * Ling 575, Professor Tjalve, Spring 2012
 * Test the conversions.
 */
public class G2PTest
{
    G2P g2p;

    public G2PTest() throws FileNotFoundException
    {
        g2p = new G2P();
    }

    @Test
    public void testAll() throws FileNotFoundException
    {
        oneTest("a b c d e f g h i j k l m n o p q r s t u v w x y z");
        oneTest("John's church churches Lurch's lunches at the lakeside marina in by the lake.");
        oneTest("Hello World!");
        oneTest("April 31 XEROX xylophone zoo oxen");
        oneTest("seven December 7 kgfiddw");
        oneTest("December 7, 1939, a date which will live in infamy!");
        oneTest("$5 $1 $983,298 $1.11 $111.22");
        oneTest("Jane");
        oneTest("Dr. Jones Dr.");
        oneTest("St. Mary's St.");
        oneTest("IBM");
        oneTest("NATO N.A.S.A");
        oneTest("glass wife face breeze phase cage garage mouse");
        oneTest("lamb doll deed care car feet foot Saint's");
        oneTest("We went to the Lisa's Paul's fleiss Fleiss' Monkey's Gerald's Blink's Glass'");
    }

    void oneTest(String input)
    {
        String output = g2p.convert(input);
        System.out.println("input \"" + input + "\" -> output \"" + output + "\"");
    }

    public static void main(String[] args) throws FileNotFoundException
    {
        G2PTest g2ptest = new G2PTest();

        System.out.println("Test sentences skipping conversion to SAMPA:");
        g2ptest.g2p.skipStage4 = true;
        g2ptest.testAll();

        System.out.println();
        System.out.println("Full pipeline:");
        g2ptest.g2p.skipStage4 = false;
        g2ptest.testAll();
    }
}
